"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createCaller = exports.createRouter = void 0;
const routes_1 = require("./routes");
const json_type_1 = require("../../json-type");
const TypeRouter_1 = require("../../json-type/system/TypeRouter");
const TypeRouterCaller_1 = require("../../reactive-rpc/common/rpc/caller/TypeRouterCaller");
const caller_1 = require("../../reactive-rpc/common/rpc/caller");
const Value_1 = require("../../reactive-rpc/common/messages/Value");
const createRouter = (services) => {
    const system = new json_type_1.TypeSystem();
    const router = new TypeRouter_1.TypeRouter({ system, routes: {} });
    const deps = { services, router };
    return (0, routes_1.routes)(deps)(router);
};
exports.createRouter = createRouter;
const createCaller = (services) => {
    const router = (0, exports.createRouter)(services);
    const caller = new TypeRouterCaller_1.TypeRouterCaller({
        router,
        wrapInternalError: (error) => {
            if (error instanceof Value_1.Value)
                return error;
            if (error instanceof caller_1.RpcError)
                return caller_1.RpcError.value(error);
            console.error(error);
            return caller_1.RpcError.valueFrom(error);
        },
    });
    return caller;
};
exports.createCaller = createCaller;
