"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BlockPatch = exports.Block = exports.BlockSeq = exports.BlockId = void 0;
const json_type_1 = require("../../../json-type");
exports.BlockId = json_type_1.t.str.options({
    title: 'Block ID',
    min: 6,
    max: 40,
});
exports.BlockSeq = json_type_1.t.num.options({
    title: 'Block Sequence Number',
    gte: 0,
    format: 'u32',
});
exports.Block = json_type_1.t.Object(json_type_1.t.prop('id', json_type_1.t.Ref('BlockId')), json_type_1.t.prop('seq', json_type_1.t.Ref('BlockSeq')), json_type_1.t.prop('created', json_type_1.t.num), json_type_1.t.prop('updated', json_type_1.t.num), json_type_1.t.prop('blob', json_type_1.t.bin));
exports.BlockPatch = json_type_1.t.Object(json_type_1.t.prop('seq', json_type_1.t.num), json_type_1.t.prop('created', json_type_1.t.num), json_type_1.t.prop('blob', json_type_1.t.bin));
